﻿/* --------------------------------
СollatingMarks

Автор:	Александр Петренко
		pan.maket@gmail.com

Совместимость проверена: СS2-cs4

Описание:
Проставляет метки для ручного подбора или контроля подобранных сфальцованых тетрадей на их внешней стороне, со смещением на высоту метки.
При необходимости проставляет дополнительные метки на внутренних листах тетради на уровне внешней метки текущей тетради.
-----------------------------------*/

with (app) {
	if (documents.length == 0) { alert('Нет открытых документов!'); exit(); }
	var myLength = activeDocument.pages.length;	// Кол-во стр. в макете
	var myDoc = activeDocument.pages;
	var myDoc1 = activeDocument;
// Создаем диалоговое окно для задания кол-ва стр. в тетради, высоты и ширины метки, отступа первой метки от верхнего края страницы и др.
	var myDialog = dialogs.add({name:'Тип переплета и параметры меток для подбора', canCancel:true});
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:'Колличество страниц в тетради:'});
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:'Высота метки, мм:'});
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:'Ширина метки, мм:'});
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:'Отступ от верхнего края страницы, мм:'});
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:'Дополнительные метки внутри тетрадей:'});
		}
	}
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			var myDTet = dropdowns.add({stringList:['24', '16', '8', '4'], selectedIndex:0});
		}
		with (dialogRows.add()) {
			var myDRecH = realEditboxes.add({editValue:5});
		}
		with (dialogRows.add()) {
			var myDRecW = realEditboxes.add({editValue:5});
		}
		with (dialogRows.add()) {
			var myDY = integerEditboxes.add({editValue:10});
		}
		with (dialogRows.add()) {
			var myDMarkInside = checkboxControls.add({checkedState:true});
		}
	}
	with (myDialog.dialogColumns.add()) { staticTexts.add({staticLabel:'    '}); }		// Косметический отступ от кнопок
	var myDisplay = myDialog.show();	// Вывод диалогового окна на экран
// Считываем значения величин из диалогового окна
	if (myDisplay) {
		var myTet = parseInt(myDTet.stringList[myDTet.selectedIndex]);		// Кол-во страниц в тетради
		var myRecH = myDRecH.editValue;										// Высота метки
		var myRecW = myDRecW.editValue/2;									// Ширина метки
		var myY = myDY.editValue;											// Отступ первой метки от верхнего края страницы
		var myMarkInside = myDMarkInside.checkedState;						// Флажок наличия меток внутри тетрадей
		myDialog.destroy();			// Освобождаем память, удаляя объект "диалог"
	}
	else { myDialog.destroy(); exit(); }
// Определение коэффициентов для каждого типа переплета
	switch (myTet) {
		case 24:
			var myKrat = 8;		// Коэффициент кратности
			var myTetL = 16;	// Страницы в неполной тетради
			var myK = 1;		// Коэффициент устанавливает неполную тетрадь в конец, для клея
			var myIns = 2;		// Коэффициент, который определяет количество меток внутри тетради
			break;
		case 16:
			var myKrat = 8;		// Коэффициент кратности
			var myTetL = 8;		// Страницы в неполной тетради
			var myK = 1;
			var myIns = 1;
			break;
		case 8:
			var myKrat = 4;		// Коэффициент кратности
			var myTetL = 4;		// Страницы в неполной тетради
			var myK = 2;		// Коэффициент устанавливает неполную тетрадь в конец, для клея
			var myIns = 0;
			break;
		case 4:
			var myKrat = 4;		// Коэффициент кратности
			var myTetL = 4;		// Страницы в неполной тетради
			var myK = 1;
			var myIns = 0;
			break;
		default:
			alert('Размер тетради задан неверно: ' + myTet); exit();	// На всякий случай
	}
// alert('myTet= ' + myTet + '; myRecH= ' + myRecH + '; myY= ' + myY + '; myIns= ' + myIn + '; ' + activeDocument.layers[1].index); exit();
// Проверка на кратность и общее кол-во страниц
	if ((myLength/myKrat != Math.round(myLength/myKrat)) || (myLength < (myTet*2 + myTetL))) {
		alert('Колличество страниц ' + myLength + ' - не кратно ' + myKrat + ' или меньше ' + (myTet*2 + myTetL));
		exit();
	}
// Проверка на наличие неполных тетрадей и их отсекание вместе с последней
	if (myLength/myTet == Math.round(myLength/myTet)) {
		var myCase = 1;						// Коэффициент определяет кол-во отсеченных тетрадей
		var myLengthT = myLength - myTet;	// Кол-во страниц в основном блоке тетрадей
	}
	else {
		myLengthT = myLength - myTet - myTetL;
		if(myLengthT/myTet == Math.round(myLengthT/myTet)) { var myCase = 2; }
		else {
			var myCase = 3;
			var myLengthT = myLength - myTet - 2*myTetL;
		}
	}
	var myI = myLengthT/myTet;					// Количество тетрадей в основном блоке
	var myPage = myDoc[0];						// Переходим на первую страницу
	var myPageBound = myPage.bounds;			// Получаем координаты углов страницы
// Проверяем поместится ли весь набор меток на высоту страницы
	if ((myI + myCase)*myRecH > (myPageBound[2] - myPageBound[0] - myY - myRecH - 10)) {
		alert('При данной высоте метки, весь набор не поместится на странице. Рекомендуемая высота не больше ' + Math.round((myPageBound[2] - myPageBound[0] - myY - myRecH - 10)/(myI + myCase)));
		exit();
	}
	var myLayer = activeDocument.layers.add({visible:true, name:'Marks'}); // Создание нового слоя для меток
// Ставим метку на 1-й странице
	var myRecBound = Array(myPageBound[0]+myY, myPageBound[1], myPageBound[0]+myY+myRecH, myPageBound[1]+myRecW);
	myRectangle(myPage, myRecBound);
// Простановка меток на основном блоке тетрадей
	for (i=1; i<=myI; i++) {
		myPage = myDoc[i*myTet-1];
		myRecBound = Array(myPageBound[0]+myY, myPageBound[3]-myRecW, myPageBound[0]+myY+myRecH, myPageBound[3]);
		myRectangle(myPage, myRecBound);
		myRecBound = Array(myPageBound[0]+myY+myRecH, myPageBound[3], myPageBound[0]+myY+2*myRecH, myPageBound[3]+myRecW);
		myRectangle(myPage, myRecBound);
		if (myMarkInside) myFor(myDoc, (i*myTet-1), myIns, myY, myRecH, myRecW);	// Функция проставляет доп. метки внутри тетради
		myY += myRecH;
	}
// Простановка меток на последней странице и неполных тетрадях
	switch (myCase) {
		// Без неполных тетрадей
		case 1:
			myPage = myDoc[i*myTet-1];
			myRecBound = Array(myPageBound[0]+myY, myPageBound[3]-myRecW, myPageBound[0]+myY+myRecH, myPageBound[3]);
			myRectangle(myPage, myRecBound);
			if (myMarkInside) myFor(myDoc, (i*myTet-1), myIns, myY, myRecH, myRecW);	// Метки внутри последней тетради
			break;
		// Одна предпоследняя неполная тетрадь
		case 2:
			myPage = myDoc[myLengthT+myTetL*myK-1];
			myRecBound = Array(myPageBound[0]+myY, myPageBound[3]-myRecW, myPageBound[0]+myY+myRecH, myPageBound[3]);
			myRectangle(myPage, myRecBound);
			myRecBound = Array(myPageBound[0]+myY+myRecH, myPageBound[3], myPageBound[0]+myY+2*myRecH, myPageBound[3]+myRecW);
			myRectangle(myPage, myRecBound);
			if (myIns == 2 && myMarkInside) {
				myFor(myDoc, (myLengthT+myTetL*myK-1), 1, myY, myRecH, myRecW);		// Метки внутри неполной тетради (16 стр.)
			}
			myPage = myDoc[myLength-1];
			myRecBound = Array(myPageBound[0]+myY+myRecH, myPageBound[3]-myRecW, myPageBound[0]+myY+2*myRecH, myPageBound[3]);
			myRectangle(myPage, myRecBound);
			if (myMarkInside) myFor(myDoc, (myLength-1), myIns, (myY+myRecH), myRecH, myRecW);	// Метки внутри последней тетради
			break;
		// Две предпоследние неполные тетради
		case 3:
			myPage = myDoc[myLengthT+myTetL-1];
			myRecBound = Array(myPageBound[0]+myY, myPageBound[3]-myRecW, myPageBound[0]+myY+myRecH, myPageBound[3]);
			myRectangle(myPage, myRecBound);
			myRecBound = Array(myPageBound[0]+myY+myRecH, myPageBound[3], myPageBound[0]+myY+2*myRecH, myPageBound[3]+myRecW);
			myRectangle(myPage, myRecBound);
			if (myMarkInside) myFor(myDoc, (myLengthT+myTetL-1), 1, myY, myRecH, myRecW);	// Метки внутри 1-й неполной тетради (16 стр.)
			myY += myRecH;
			myPage = myDoc[myLengthT+2*myTetL-1];
			myRecBound = Array(myPageBound[0]+myY, myPageBound[3]-myRecW, myPageBound[0]+myY+myRecH, myPageBound[3]);
			myRectangle(myPage, myRecBound);
			myRecBound = Array(myPageBound[0]+myY+myRecH, myPageBound[3], myPageBound[0]+myY+2*myRecH, myPageBound[3]+myRecW);
			myRectangle(myPage, myRecBound);
			if (myMarkInside) myFor(myDoc, (myLengthT+2*myTetL-1), 1, myY, myRecH, myRecW);	// Метки внутри 2-й неполной тетради (16 стр.)
			myPage = myDoc[myLength-1];
			myRecBound = Array(myPageBound[0]+myY+myRecH, myPageBound[3]-myRecW, myPageBound[0]+myY+2*myRecH, myPageBound[3]);
			myRectangle(myPage, myRecBound);
			if (myMarkInside) myFor(myDoc, (myLength-1), myIns, myY+myRecH, myRecH, myRecW);	// Метки внутри последней тетради
			break;
	}
	myLayer.locked = true;			// Блокирование слоя с метками
	activeDocument.layoutWindows[0].activeLayer = activeDocument.layers[myLayer.index + 1];		// Переход на предыдущий активный слой
}
// Функция проставляет доп. метки внутри тетради
function myFor(myDoc1, myJ, myIns1, myY1, myRecH1, myRecW1) {
	for (j=1; j<=myIns1; j++) {
		var myPage1 = myDoc1[myJ-4*j];
		var myRecBound1 = Array(myPageBound[0]+myY1, myPageBound[3]-myRecW1, myPageBound[0]+myY1+myRecH1, myPageBound[3]);
		myRectangle(myPage1, myRecBound1);
		myPage1 = myDoc1[myJ-8*(myIns1+1)+4*j];
		myRecBound1 = Array(myPageBound[0]+myY1, myPageBound[3], myPageBound[0]+myY1+myRecH1, myPageBound[3]+myRecW1);
		myRectangle(myPage1, myRecBound1);
	}
}
// Функция, которая рисует метки
function myRectangle(myP, myB) {
	myP.rectangles.add(undefined, undefined, undefined, { strokeWeight:0, fillColor:'Black', fillTint:30, geometricBounds:myB });
}